#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <cmath>
#include <list>
#include <map>
#include <queue>
#include <stack>
#include <set>
#include <cassert>
#include <climits>
#include <functional>
#include <bitset>
 
#define pb push_back
#define mp make_pair
#define all(x) x.begin(),x.end()
#define rep(i,n) for(int i=0;i<n;i++)
#define print(x) cout<<#x<<" is "<<x<<endl;
#define inf 2000000000
#define eps 1e-8
#define fill(x,y) memset(x,y,sizeof(x))
#define Size(x) (int(x.size()))
#define FOR(k,a,b) for(typeof(a) k=(a); k < (b); ++k)
typedef long long ll;
using namespace std;
 
#define dim 3
 
struct matrix {
    int a[dim][dim];
};
 
#define MOD 1000000007
 
matrix mul(matrix x, matrix y) {
    matrix res;
    FOR(a,0,dim) FOR(b,0,dim) res.a[a][b] = 0;
    FOR(a,0,dim) FOR(b,0,dim) FOR(c,0,dim) {
	res.a[a][c] += (x.a[a][b] * ll(y.a[b][c])) % MOD;
	res.a[a][c] %= MOD;
    }
    return res;
}
 
matrix power(matrix m, int n) {
    if(n == 1) return m;
    matrix u = mul(m, m);
    u = power(u, n/2);
    if(n&1) u = mul(u, m);
    return u;
}
 
matrix M, C, RP, A;
 
int main() {
    FOR(a,0,dim) FOR(b,0,dim) M.a[a][b] = 0;
    M.a[0][0] = M.a[0][1] = 2;
    M.a[1][0] = M.a[2][1] = 1;
    C.a[0][0] = 3;
    C.a[1][0] = C.a[2][0] = 1;
    int nt;
    scanf("%d",&nt);
    while(nt--) {
	int n;
	scanf("%d",&n);
	if(n <= 2) {
	    if(n==2)printf("3\n");
	    else printf("1\n");
	    continue;
	}
	int rs = n - 2;
	RP = power(M, rs);
	A = mul(RP, C);
	printf("%d\n",A.a[0][0]);
    }
    return 0;
}
 
